package com.lantone.qc.kernel.util;

import net.sf.cglib.proxy.MethodInterceptor;
import net.sf.cglib.proxy.MethodProxy;
import org.springframework.beans.factory.annotation.Autowired;

import java.lang.reflect.Method;
import java.util.Map;

/**
 * @Description:
 * @author: rengb
 * @time: 2020/3/12 17:52
 */
public class DiagMethodInterceptor implements MethodInterceptor {

    @Autowired
    private RedisUtil redisUtil;

    @Override
    public Object intercept(Object obj, Method method, Object[] args, MethodProxy proxy) throws Throwable {
        if (method.getName().equals("setName")) {
            Map<String, String> diagRedisMap = (Map<String, String>)redisUtil.get(KernelConstants.CONCEPT_DIAG_HOSPITAL_REFLECT);
            String hospitalDiagName = args[0].toString();
            args[0] = diagRedisMap.get(hospitalDiagName) == null ? "" : diagRedisMap.get(hospitalDiagName);
        }
        Object object = proxy.invokeSuper(obj, args);
        return object;
    }

}